=== modified file 'src/com/goldencode/p2j/uast/ClassDefinition.java'
--- old/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/ClassDefinition.java	2022-05-23 20:10:15 +0000
@@ -1258,46 +1476,57 @@
    }
 
    /**
-    * Set the converted, fully qualified Java name, for this class.
-    * 
-    * @param    name
-    *           The qualified Java name.
-    */
-   public void setJavaClassName(String name)
-   {
-      this.javaClassName = name;
+    * Set the converted Java package and Java class name.
+    * 
+    * @param    pkg
+    *           Full Java package in dotted notation (no class name).
+    * @param    cls
+    *           Simple Java class name, without any package prefix.
+    */
+   public void setJavaClassName(String pkg, String cls)
+   {
+      this.javaPackage   = pkg;
+      this.javaClassName = cls;
+   }
+   
+   /**
+    * Get the converted fully qualified Java class name for this definition.
+    * 
+    * @return   The converted fully qualified Java class name or {@code null} if it has not yet been
+    *           computed.
+    */
+   public String getQualifiedJavaName()
+   {
+      String clsName = getSimpleJavaName();
+      
+      if (clsName == null)
+      {
+         return null;
+      }
+      
+      String pkg = getJavaPackage();
+      
+      return (pkg == null || pkg.isEmpty()) ? clsName : pkg + "." + clsName; 
    }
    
    /**
     * Get the converted simple Java class name for this definition.
     * 
-    * @return   See above.
+    * @return   The converted Java class name or {@code null} if it has not yet been computed.
     */
-   public String getJavaSimpleName()
+   public String getSimpleJavaName()
    {
-      if (javaClassName == null)
-      {
-         return null; // not yet computed
-      }
-      
-      int dotIdx = javaClassName.lastIndexOf('.');
-      return dotIdx < 0 ? javaClassName : javaClassName.substring(dotIdx + 1);
+      return javaClassName;
    }
    
    /**
     * Get the converted Java package for this definition.
     * 
-    * @return   See above.
+    * @return   The converted Java package name or {@code null} if it has not yet been computed.
     */
    public String getJavaPackage()
    {
-      if (javaClassName == null)
-      {
-         return null; // not yet computed
-      }
-
-      int dotIdx = javaClassName.lastIndexOf('.');
-      return dotIdx < 0 ? "" : javaClassName.substring(0, dotIdx);
+      return javaPackage;
    }
    
    /**
@@ -1328,7 +1557,7 @@
     */
    public Set<String> getInterfaces()
    {
-      return interfaces == null ? null : new HashSet<String>(interfaces);
+      return ifaces == null ? null : new HashSet<String>(ifaces);
    }
    
    /**
@@ -1415,7 +1644,7 @@
    }
 
    /**
-    * Add the named method to this class.
+    * Add the named method to this class. This is only called during parsing. 
     *
     * @param    name
     *           Method name.
@@ -1433,18 +1662,12 @@
     *           The AST for the method's return type.  This is used to copy OO annotations back to 
     *           the method node.
     */
-   public void addMethod(String  name,
-                         int     type,
-                         int     access,
-                         boolean isStatic,
-                         Aast    node,
-                         Aast    ret)
+   public void addMethod(String name, int type, int access, boolean isStatic, Aast node, Aast ret)
    {
       ParameterKey[] sig = SymbolResolver.calculateDefinitionSignature(node);
       
       // methods provide overloading so we can't use the simple member store mapping approach
       
-      String key = name.toLowerCase();
       boolean isPreScan = SymbolResolver.isPreScan();
       
       int extent = 0;
@@ -1452,59 +1675,50 @@
       
       synchronized (lock)
       {
-         if (imethods == null)
-         {
-            imethods = new HashMap<>();
-            smethods = new HashMap<>();
-         }
-         
-         Map<String, Map<SignatureKey, MemberData>> store = isStatic ? smethods : imethods;
-         Map<SignatureKey, MemberData>              defs  = store.get(key);
+         Map<SignatureKey, MemberData> defs = getMethodStore(name, isStatic);
       
-         if (defs == null)
-         {
-            defs = new HashMap<>();
-            store.put(key, defs);
-         }
-         
          Map<String, Object> retType = new HashMap<>();
+         
          if (ret != null)
          {
             Iterator<String> iter = ret.annotationKeys();
+            
             while (iter.hasNext())
             {
                String akey = iter.next();
                retType.put(akey, ret.getAnnotation(akey));
             }
          }
-         String qname = (String) retType.get("qualified");
-         MemberData mdat =
-            new MemberData(name, null, sig, type, access, isStatic, qname, this, tempIdx, retType);
-         mdat.ast = node;
-
-         extent = mdat.extent = SymbolResolver.readExtent(node);
          
+         String     qname    = (String) retType.get("qualified");
+         boolean    override = node.getImmediateChild(KW_OVERRIDE, null) != null;
+         boolean    abstr    = node.getImmediateChild(KW_ABSTRACT, null) != null;
+         boolean    register = !isPreScan || (builtin && !dotnet);
          MemberData prevMdat = defs.get(new SignatureKey(sig));
+         
+         extent = SymbolResolver.readExtent(node);
+         
+         MemberData mdat = createMethod(defs, name, sig, access, isStatic, type, qname, 
+                                        null, extent, tempIdx, override, abstr, retType, register);
+         
+         mdat.ast = node;
+         
          if (prevMdat != null)
          {
             if (isPreScan)
             {
                // this can happen if we are referencing this class via a USING from an USING defined
-               // in this file... in this case, inherit the tempidx, but show an warning.
-               MemberData dat = defs.get(new SignatureKey(sig));
+               // in this file... in this case, inherit the tempidx, but show a warning.
                
-               // GES_TODO: re-enable this
+               // TODO: these show up for constructors and many other cases; we can't fill up the logs with
+               //       useless warnings, so we will disable for now
                // System.out.printf("\nERROR: duplicate method definition!\n");
-               // System.out.printf("EXISTING %s\n", dat.toString());
+               // System.out.printf("EXISTING %s\n", prevMdat.toString());
                // System.out.printf("DUPLICATE %s\n at %s", mdat.toString(), node.dumpTree());
-               
-               // return;
-            }
-            // else
-            {
-               // inherit the tempIdx computed at the pre-scan phase.
-               mdat.tempIdx = prevMdat.tempIdx;
-            }
+            }
+            
+            // inherit the tempIdx computed at the pre-scan phase.
+            mdat.tempIdx = prevMdat.tempIdx;
          }
          else
          {
@@ -1521,35 +1735,23 @@
          }
          
          mTempIdx = mdat.tempIdx;
-         defs.put(new SignatureKey(sig), mdat);
-         
-         if (!isPreScan || (builtin && !dotnet))
-         {
-            String javaname = null;
-            if (builtin)
-            {
-               String legacySignature = SymbolResolver.calculateLegacySignature(name, sig);
-               javaname = javaMethodNames.get(legacySignature);
-            }
-            SymbolResolver.trackMethodSignature(javaname, name, sig);
-         }
       }
       
       // annotate the given node
       if (node != null)
       {
          node.putAnnotation("name", name);
-         node.putAnnotation("return_type", new Long(type));
-         node.putAnnotation("signature", renderSignature(name, sig)); 
-         node.putAnnotation("access-mode", new Long(access));
-         node.putAnnotation("static", new Boolean(isStatic));
+         node.putAnnotation("return_type", (long) type);
+         node.putAnnotation("signature", SymbolResolver.calculateLegacySignature(name, sig)); 
+         node.putAnnotation("access-mode", (long) access);
+         node.putAnnotation("static", isStatic);
          node.putAnnotation("oo-data-store", DataStoreType.METHOD.toString());
-         node.putAnnotation("tempidx", new Long(mTempIdx));
+         node.putAnnotation("tempidx", (long) mTempIdx);
          node.putAnnotation("tempidx-file", this.filename);
          
          if (extent != 0)
          {
-            node.putAnnotation("extent", new Long(extent));
+            node.putAnnotation("extent", (long) extent);
          }
          
          if (ret != null && ret.isAnnotation("qualified"))
@@ -1589,6 +1791,12 @@
                }         
             }
          }
+         
+         // annotate the parameters
+         SymbolResolver.processDefinitionSignature(node, (Aast ast, ParameterKey pk, int idx) -> 
+         {
+            ast.putAnnotation("jtype", pk.toJava());
+         });
       }
    }
       
@@ -1661,7 +1869,8 @@
       if (node != null)
       {
          // go ahead and annotate the chp_wrapper right now too
-         MemberData mdat = lookupMethodWorker(mname, signature, access, isStatic, internal, node);
+         MethodSearchResult found = lookupMethodWorker(mname, signature, access, isStatic, internal, node);
+         MemberData         mdat    = (found == null) ?  null : found.data;
          
          if (mdat != null)
          {
@@ -1673,14 +1882,14 @@
             }
             
             // the access mode won't necessarily be the same as that passed in
-            node.putAnnotation("access-mode", new Long(mdat.access));
-            node.putAnnotation("static", new Boolean(mdat.isStatic));
+            node.putAnnotation("access-mode", (long) mdat.access);
+            node.putAnnotation("static", mdat.isStatic);
             if (mdat.modes != null && !mdat.modes.isEmpty())
             {
                node.putAnnotation("param_modes", mdat.modes);
             }
             
-            node.putAnnotation("tempidx", new Long(mdat.tempIdx));
+            node.putAnnotation("tempidx", (long) mdat.tempIdx);
             node.putAnnotation("tempidx-file", mdat.container.filename);
             
             node.putAnnotation("found-in-cls", mdat.container.name);
@@ -1692,21 +1901,37 @@
             
             if (mdat.extent != 0)
             {
-               node.putAnnotation("extent", new Long(mdat.extent));
-            }
-            
-            if (mdat.container.builtin && !mdat.container.dotnet)
-            {
-               String legacySignature = SymbolResolver.calculateLegacySignature(mdat.name, mdat.signature);
-               String javaname = mdat.container.getConvertedMethodName(legacySignature);
-               if (javaname != null)
-               {
-                  node.putAnnotation("javaname", javaname);
-               }
-            }
-            
-            annotateCallSignature(node, signature, mdat.signature);
-            node.putAnnotation("signature", renderSignature(mdat.name, mdat.signature));
+               node.putAnnotation("extent", (long) mdat.extent);
+            }
+
+            // we cannot annotate the javaname at this point because we are currently in the non-pre-scan 
+            // parse of a file and:
+            // - a method call can reference a method definition that appears later in the file so the
+            //   parsing must rely upon the pre-scan method def instead of the regular parse method def
+            //   where the javaname is calculated
+            // - can be a reference to a constructor which we currently don't calculate java names
+            //
+            // if (mdat.javaname != null)
+            // {
+            //    node.putAnnotation("javaname", mdat.javaname);
+            // }
+            // else
+            // {
+            //    // constructors don't have a javaname set
+            //    if (!getSimpleName().equalsIgnoreCase(mname))
+            //    {
+            //       System.out.printf("WARNING: Missing javaname in %s\n\nfound %s\nfor location %s\n",
+            //                         getName(),
+            //                         mdat.toString(),
+            //                         node.dumpTree(true));
+            //    }
+            // }
+            
+            annotateCallSignature(node, signature, mdat.signature, found.getOverrides());
+            
+            String legacySig = SymbolResolver.calculateLegacySignature(mdat.name, mdat.signature);
+            node.putAnnotation("signature", legacySig);
+            
             if (isBuiltIn())
             {
                // for builtin method calls, save the typelist too
@@ -1751,19 +1976,9 @@
          }
          else
          {
-            // check if there are POLY arguments (BaseDataType signature); if so, mark this call
-            // with 'dynamic', so conversion rules can emit a dynamic call for it
-            boolean dynamic = false;
-            for (ParameterKey key : signature)
-            {
-               if ("BaseDataType".equals(key.type))
-               {
-                  dynamic = true;
-                  break;
-               }
-            }
-            
-            if (dynamic)
+            // dynamic cases will have a non-null result; this may be for table-handle parms, dataset-handle
+            // parms or POLY parms
+            if (found != null && found.isDynamic())
             {
                node.putAnnotation("dynamic", true);
                if (isStatic)
@@ -1792,8 +2007,11 @@
    }
       
    /**
-    * Add a data member (variable) or property to this class.
+    * Add a data member (variable, property, enum or event) to this class.
     *
+    * @param    type
+    *           The token type of the member being added. This will be DEFINE_VARIABLE, DEFINE_PROPERTY,
+    *           DEFINE_EVENT or DEFINE_ENUM.
     * @param    name
     *           Variable or property name.
     * @param    var
@@ -1811,7 +2029,8 @@
     * @param    provisional
     *           {@code true} if this definition has not been finalized.
     */
-   public void addVariable(String   name,
+   public void addVariable(int      type,
+                           String   name,
                            Variable var,
                            Aast     node,
                            int      access,
@@ -1831,9 +2050,25 @@
       
       mdat.setProvisional(provisional);
       
+      if (type == DEFINE_ENUM)
+      {
+         String ename = name.toLowerCase();
+         
+         if (javaEnumNames.containsKey(ename))
+         {
+            mdat.javaname = javaEnumNames.get(ename);
+         }
+      }
+      
+      if (mdat.javaname == null)
+      {
+         mdat.javaname = nconvert.convert(name, MatchPhraseConstants.TYPE_VARIABLE);
+      }
+      
       if (node != null)
       {
          node.putAnnotation("oo-data-store", DataStoreType.VAR.toString());
+         node.putAnnotation("javaname", mdat.javaname);
       }
    }
    
@@ -1863,6 +2098,50 @@
    }
    
    /**
+    * Obtain the Java name of the data member the name and access mode.
+    * <p>
+    * If the resource does not exist in this class definition the parent (if one exists) will be checked.
+    * This means a recursive call can occur here.
+    *
+    * @param    name
+    *           Variable or property name.
+    * @param    access
+    *           Access mode ({@code KW_PUBLIC}, {@code KW_PROTECTD} or {@code KW_PRIVATE}).
+    * @param    isStatic    
+    *           <code>true</code> if this is a static reference.
+    *
+    * @return   The Java name of the data member or {@code null} if no such variable exists. 
+    */
+   public String lookupVariableJavaName(String name, int access, boolean isStatic)
+   {
+      MemberData mdat = lookupHierarchy(DataStoreType.VAR, name, access, isStatic);
+      return (mdat == null) ? null : mdat.javaname;
+   }
+   
+   /**
+    * Obtain the extent of the data member the name and access mode.
+    * <p>
+    * If the resource does not exist in this class definition the parent (if one exists) will be checked.
+    * This means a recursive call can occur here.
+    *
+    * @param    name
+    *           Variable or property name.
+    * @param    access
+    *           Access mode ({@code KW_PUBLIC}, {@code KW_PROTECTD} or {@code KW_PRIVATE}).
+    * @param    isStatic    
+    *           <code>true</code> if this is a static reference.
+    *
+    * @return   The extent of the data member or 0 if the variable is not an extent var or if no such
+    *           variable exists. 
+    */
+   public long lookupVariableExtent(String name, int access, boolean isStatic)
+   {
+      MemberData mdat = lookupHierarchy(DataStoreType.VAR, name, access, isStatic);
+      return (mdat == null || mdat.var.getExtent() == 0) ? 0L : (long) mdat.var.getExtent();
+   }
+   
+   
+   /**
     * Obtain the fully qualified class name of the object instance 
     * represented by the data member (variable) or property given
     * the name and access mode.
@@ -1883,9 +2162,7 @@
     *           represented by this variable or data member, or 
     *           <code>null</code> if no such variable exists. 
     */
-   public String lookupVariableClassName(String  name,
-                                         int     access,
-                                         boolean isStatic)
+   public String lookupVariableClassName(String  name, int access, boolean isStatic)
    {
       MemberData mdat = lookupHierarchy(DataStoreType.VAR, name, access, isStatic);
       return (mdat == null) ? null : mdat.qname;
@@ -2362,44 +2639,26 @@
     * @param    func
     *           Delegated code to calculate the value.
     * @param    continu
-    *           A condition which if it returns <code>true</code>, then the next schema
-    *           dictionary should be tried.  On <code>false</code>, the current result is
-    *           returned.
+    *           A condition which if it returns <code>true</code>, then the next parent should be tried.
+    *           On <code>false</code>, the current result is returned.
     * @param    defVal
     *           Default value to return if no parents exist.
+    * @param    inherit
+    *           {@code true} to search the inheritance hierarchy for a match.
+    * @param    ifaces
+    *           {@code true} to search interfaces (if any exist) in addition to direct parents.
     *
     * @return   The calculated value or {@code null} if no value is calculated.
     */
    public <R> R calcFromParentGraph(java.util.function.Function<ClassDefinition, R> func,
                                     Predicate<R>                                    continu,
-                                    R                                               defVal)
+                                    R                                               defVal,
+                                    boolean                                         inherit,
+                                    boolean                                         ifaces)
    {
-      R result = defVal;
-      
-      if (parents != null)
-      {
-         for (ClassDefinition parent : parents)
-         {
-            result = func.apply(parent);
-            
-            if (!continu.test(result))
-            {
-               break;
-            }
-            else
-            {
-               // recurse
-               result = parent.calcFromParentGraph(func, continu, defVal);
-               
-               if (!continu.test(result))
-               {
-                  break;
-               }
-            }
-         }
-      }
-      
-      return result;
+      Set<String> processed = new HashSet<>();
+      
+      return calcFromParentGraphWorker(func, continu, defVal, processed, inherit, ifaces);
    }
    
    /**
@@ -2422,183 +2681,78 @@
    }
    
    /**
-    * Initialize the converted class details using this definition.
-    * <p>
-    * This will expose to the conversion rules details about the class member's, like converted
-    * Java name.
-    * 
-    * @param    cclass
-    *           The instance which needs to be initialized.
+    * Recursively process the parent hierarchy to calculate a value.  This searches the list of
+    * parents, checking UP before SIDEWAYS.
+    *
+    * @param    func
+    *           Delegated code to calculate the value.
+    * @param    continu
+    *           A condition which if it returns <code>true</code>, then the next parent should be tried.
+    *           On <code>false</code>, the current result is returned.
+    * @param    defVal
+    *           Default value to return if no parents exist.
+    * @param    inherit
+    *           {@code true} to search the inheritance hierarchy for a match.
+    * @param    ifaces
+    *           {@code true} to search interfaces (if any exist) in addition to direct parents.
+    *
+    * @return   The calculated value or {@code null} if no value is calculated.
     */
-   void initialize(ConvertedClassName cclass)
+   private <R> R calcFromParentGraphWorker(java.util.function.Function<ClassDefinition, R> func,
+                                          Predicate<R>                                    continu,
+                                          R                                               defVal,
+                                          Set<String>                                     processed,
+                                          boolean                                         inherit,
+                                          boolean                                         ifaces)
    {
-      Map<String, Map<SignatureKey, MemberData>>[] methods = new Map[] { imethods, smethods };
-
-      // methods. this includes the get-,set-,length-of, resize- methods for OO properties, but
-      // only for non-builtin classes
-      for (Map<String, Map<SignatureKey, MemberData>> mthds : methods)
-      {
-         if (mthds == null)
-         {
-            continue;
-         }
-         
-         for (String key : mthds.keySet())
-         {
-            Map<SignatureKey, MemberData> imthds = mthds.get(key);
-            for (SignatureKey mkey : imthds.keySet())
-            {
-               MemberData mdata = imthds.get(mkey);
-               
-               String legacySignature = SymbolResolver.calculateLegacySignature(mdata.name, 
-                                                                                mdata.signature);
-               String javaname = javaMethodNames.get(legacySignature);
-               
-               if (builtin || isEnum())
-               {
-                  if (javaname == null)
-                  {
-                     System.out.println("WARNING: Can't locate converted method for " + 
-                                        legacySignature  + " in " + javaClassName);
-
-                     javaname = nconvert.convert(mdata.name, MatchPhraseConstants.TYPE_METHOD);
-                  }
-
-                  cclass.addMethod(mdata.name, javaname, mdata.signature);
-               }
-               else
-               {
-                  cclass.addMethod(mdata.name, javaname, mdata.astId);
-               }
-            }
-         }
-      }
-      
-      Map<String, MemberData> ivar = getMemberStore(DataStoreType.VAR, false);
-      Map<String, MemberData> svar = getMemberStore(DataStoreType.VAR, true);
-      Map<String, MemberData>[] variables = new Map[] { ivar, svar };
-
-      // variables[extents] and properties
-      String[] extPrefixes = {"get", "set", "length-of", "resize" };
-      String[] propPrefixes = {"get", "set" };
-      for (Map<String, MemberData> vars : variables)
-      {
-         if (vars == null)
-         {
-            continue;
-         }
-         
-         for (String key : vars.keySet())
-         {
-            MemberData vdata = vars.get(key);
-            
-            if (builtin)
-            {
-               if (vdata.var.isProp())
-               {
-                  String datatype = SymbolResolver.translateType(vdata.type, null);
-                  if ("object".equals(datatype))
-                  {
-                     datatype = String.format("object <? extends %s>", vdata.qname);
-                  }
-                  int extent = vdata.var.getExtent();
-                  String ext = extent == 0 
-                                 ? "" 
-                                 : "[" + (extent > 0 ? Integer.toString(extent) : "") +"]";
-
-                  // add property methods
-                  String[] prefixes = extent != 0 ? extPrefixes : propPrefixes;
-                  for (String mprefix : prefixes)
-                  {
-                     ParameterKey[] signature = null;
-                     switch (mprefix)
-                     {
-                        case "get":
-                           signature = new ParameterKey[] {};
-                           break;
-                        case "set":
-                           signature = new ParameterKey[]
-                           {
-                              new ParameterKey(ProgressParserTokenTypes.KW_INPUT, datatype + ext)
-                           };
-                           break;
-                        case "length-of":
-                           signature = new ParameterKey[] {};
-                           break;
-                        case "resize":
-                           signature = new ParameterKey[]
-                           {
-                              new ParameterKey(ProgressParserTokenTypes.KW_INPUT, "int64")
-                           };
-                           break;
-                     }
-                     
-                     String legacyName = cclass.disambiguateLegacyPropertyName(mprefix, vdata.name);
-                     String legacySignature = 
-                        SymbolResolver.calculateLegacySignature(legacyName, signature);
-                     String javaname = javaMethodNames.get(legacySignature);
-                     if (javaname == null)
-                     {
-                        System.out.println("WARNING: Can't locate converted method for " + 
-                                           legacySignature  + " in " + javaClassName);
-                        
-                        javaname = nconvert.convert(legacyName, MatchPhraseConstants.TYPE_METHOD);
-                     }
-
-                     cclass.addMethod(legacyName, javaname, signature);
-                     
-                     // add the indexed getter and setter for the extent property
-                     if (vdata.var.getExtent() != 0 && ("get".equals(mprefix) || "set".equals(mprefix)))
-                     {
-                        signature = null;
-                        switch (mprefix)
-                        {
-                           case "get":
-                              signature = new ParameterKey[]
-                              {
-                                 new ParameterKey(ProgressParserTokenTypes.KW_INPUT, "int64"),
-                              };
-                              break;
-                           case "set":
-                              signature = new ParameterKey[]
-                              {
-                                 new ParameterKey(ProgressParserTokenTypes.KW_INPUT, datatype),
-                                 new ParameterKey(ProgressParserTokenTypes.KW_INPUT, "int64")
-                              };
-                              break;
-                        }
-                        
-                        legacyName = cclass.disambiguateLegacyPropertyName(mprefix, vdata.name);
-                        legacySignature = SymbolResolver.calculateLegacySignature(legacyName, signature);
-                        javaname = javaMethodNames.get(legacySignature);
-                        if (javaname == null)
-                        {
-                           System.out.println("WARNING: Can't locate converted method for " + 
-                                              legacySignature  + " in " + javaClassName);
-                           
-                           javaname = nconvert.convert(legacyName, MatchPhraseConstants.TYPE_METHOD);
-                        }
-
-                        cclass.addMethod(legacyName, javaname, signature);
-                     }
-                  }
-               }
-               else if (isEnum() && builtin)
-               {
-                  vdata.javaname = javaEnumNames.get(vdata.name.toLowerCase());
-               }
-               
-               if (vdata.javaname == null)
-               {
-                  vdata.javaname = nconvert.convert(vdata.name, MatchPhraseConstants.TYPE_VARIABLE);
-               }
-            }
-            
-            cclass.addVariable(vdata.name, 
-                               vdata.javaname, 
-                               vdata.var.getExtent() == 0 ? null : (long) vdata.var.getExtent());
-         }
-      }
+      R result = defVal;
+      
+      int start = 0;
+      int num   = ((inherit && parents != null) ? parents.length : 0) +
+                  ((ifaces && interfaces != null) ? interfaces.length : 0);
+      
+      ClassDefinition[] list = new ClassDefinition[num];
+      
+      if (inherit && parents != null)
+      {
+         System.arraycopy(parents, 0, list, start, parents.length);
+         start = parents.length;
+      }
+      
+      if (ifaces && interfaces != null)
+      {
+         System.arraycopy(interfaces, 0, list, start, interfaces.length);
+      }
+      
+      for (ClassDefinition parent : list)
+      {
+         // avoid duplicate processing
+         if (processed.contains(parent.getName()))
+         {
+            continue;
+         }
+         
+         processed.add(parent.getName());
+         
+         result = func.apply(parent);
+
+         if (!continu.test(result))
+         {
+            break;
+         }
+         else
+         {
+            // recurse
+            result = parent.calcFromParentGraphWorker(func, continu, defVal, processed, inherit, ifaces);
+            
+            if (!continu.test(result))
+            {
+               break;
+            }
+         }
+      }
+      
+      return result;
    }
    
    /**
@@ -2649,6 +2803,38 @@
    }
    
    /**
+    * Get the correct map of method signatures to member data instances.  This must only be called when the
+    * lock instance is owned. 
+    *
+    * @param    name
+    *           Method name.
+    * @param    isStatic
+    *           <code>true</code> if the method is static.
+    *           
+    * @return   The method map.
+    */   
+   private Map<SignatureKey, MemberData> getMethodStore(String name, boolean isStatic)
+   {
+      if (imethods == null)
+      {
+         imethods = new HashMap<>();
+         smethods = new HashMap<>();
+      }
+
+      Map<String, Map<SignatureKey, MemberData>> store = isStatic ? smethods : imethods;
+      String                                     key   = name.toLowerCase();
+      Map<SignatureKey, MemberData>              defs  = store.get(key);
+   
+      if (defs == null)
+      {
+         defs = new HashMap<>();
+         store.put(key, defs);
+      }
+
+      return defs;
+   }
+   
+   /**
     * Obtain the member given the name and access mode. If the member does not exist in
     * this class definition the parent (if one exists) will be checked.
     *
